//------------------------------------------------------------------------
//DirectInputNX	
//------------------------------------------------------------------------
#include "stdafx.h"
#include "VixarLibrary.h"

//------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------
CDirectInput::CDirectInput(void)
{
	m_pDirectInput = NULL;
	m_pKeyboard = NULL;
}

//------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------
CDirectInput::~CDirectInput(void)
{
	if (m_pKeyboard)
	{
		m_pKeyboard->Unacquire();
	}
	//
	SAFE_RELEASE(m_pKeyboard);
	//
	SAFE_RELEASE(m_pDirectInput);
}

//------------------------------------------------------------------------
//DirectInput̐
//------------------------------------------------------------------------
HRESULT CDirectInput::CreateDirectInput(HWND hWnd)
{
	HRESULT	hr;
	DWORD	dwCoopFlags;

	// L[{[h擾
	dwCoopFlags = DISCL_NONEXCLUSIVE | DISCL_FOREGROUND;

	// DirectInput̃|C^擾
	if (FAILED(hr = DirectInput8Create(GetModuleHandle(NULL), DIRECTINPUT_VERSION, IID_IDirectInput8, (VOID**)&m_pDirectInput, NULL)))
	{
		return hr;
	}
	// L[{[hfoCXւ̃C^[tF[X擾
	if (FAILED(hr = m_pDirectInput->CreateDevice(GUID_SysKeyboard, &m_pKeyboard, NULL)))
	{
		return hr;
	}
	// foCX̃f[^`ݒ肵܂
	if (FAILED(hr = m_pKeyboard->SetDataFormat(&c_dfDIKeyboard)))
	{
		return hr;
	}
	// foCX̃CX^Xɑ΂鋦xmB
	hr = m_pKeyboard->SetCooperativeLevel(hWnd, dwCoopFlags);
	if (hr == DIERR_UNSUPPORTED)
	{
        MessageBox(NULL,TEXT("DirectInput̏Ɏs"),TEXT("ERROR"),MB_OK);
		return S_OK;
	}
	//sꍇ
	if (FAILED(hr))
	{
		return hr;
	}
	// ̓foCXւ̃ANZX擾
	m_pKeyboard->Acquire();

	return S_OK;
}

//------------------------------------------------------------------------
//L[{[h͂̎擾
//------------------------------------------------------------------------
bool CDirectInput::GetKeyboardInput(int key,int& flag) 
{ 
    char     buffer[256]; 
    HRESULT  hr; 

	//L[{[hԎ擾
	hr = m_pKeyboard->GetDeviceState(sizeof(buffer),(LPVOID)&buffer); 
	//sꍇ
	if FAILED(hr) 
    { 
        return false;
    }

	if(buffer[key] & 0x80)
	{
		if (flag==FREE_KEY)
		{
			//L[ꂽ
			flag=PUSH_KEY;
		}
		else
		{
			//L[ςȂ
			flag=HOLD_KEY;
		}
		return true;
	}
	else
	{
		if (flag==PUSH_KEY || flag==HOLD_KEY)
		{
			//L[ꂽ
			flag=PULL_KEY;
		}
		else
		{
			//L[ςȂ
			flag=FREE_KEY;
		}
	}

	return false;
}

//------------------------------------------------------------------------
//ANZX̊Ǘ
//------------------------------------------------------------------------
void CDirectInput::SetAcquire(bool b)
{
	if(m_pKeyboard==NULL)
	{
		return;
	}
	if(b)
	{
		m_pKeyboard->Acquire();
	}
	else
	{
		m_pKeyboard->Unacquire();
	}
}
