//------------------------------------------------------------------------
//Face.cpp	
//------------------------------------------------------------------------
#include "stdafx.h"
#include "VixarLibrary.h"

//------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------
CFace::CFace()
{
}

//------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------
CFace::~CFace()
{
}

//------------------------------------------------------------------------
//}eAԍZbg
//------------------------------------------------------------------------
void CFace::SetMaterial(int material)
{
	m_material = material;
}

//------------------------------------------------------------------------
//}eAԍ擾
//------------------------------------------------------------------------
int CFace::GetMaterial() const
{
	return m_material;
}

//------------------------------------------------------------------------
//_CfbNXǉ
//------------------------------------------------------------------------
void CFace::PushBackIndex(int i)
{
	m_index.push_back(i);
}

//------------------------------------------------------------------------
//_CfbNXTCY擾
//------------------------------------------------------------------------
int CFace::GetIndexSize() const
{
	return (int)m_index.size();
}

//------------------------------------------------------------------------
//_CfbNX擾
//------------------------------------------------------------------------
UINT CFace::GetIndex(UINT i)
{
	return (i<m_index.size())?m_index[i]:m_index[m_index.size()-1];
}

//------------------------------------------------------------------------
//UW擾
//------------------------------------------------------------------------
float CFace::GetU(UINT i)
{
	return (m_uv.size()>i)?m_uv[i].m_u:0.0f;
}

//------------------------------------------------------------------------
//VW擾
//------------------------------------------------------------------------
float CFace::GetV(UINT i)
{
	return (m_uv.size()>i)?m_uv[i].m_v:0.0f;
}

//------------------------------------------------------------------------
//UVWzTCY擾
//------------------------------------------------------------------------
int CFace::GetUVSize()
{
	return (int)m_uv.size();
}

//------------------------------------------------------------------------
//UVWzɒǉ
//------------------------------------------------------------------------
void CFace::PushBackUV(const CUV& i)
{
	m_uv.push_back(i);
}

//------------------------------------------------------------------------
//@Zbg
//------------------------------------------------------------------------
void CFace::SetNormal(D3DXVECTOR3 normal)
{
	m_normal = normal;
}

//------------------------------------------------------------------------
//@擾
//------------------------------------------------------------------------
D3DXVECTOR3 CFace::GetNormal() const
{
	return m_normal;
}

//------------------------------------------------------------------------
//@̐K
//------------------------------------------------------------------------
void CFace::Normalize()
{
	float x = m_normal.x;
	float y = m_normal.y;
	float z = m_normal.z;
	float length = sqrt(x*x+y*y+z*z);
	if ( length == 0 )
	{
		m_normal = D3DXVECTOR3(0,1,0);
	}
	else
	{
		m_normal /= length;
	}
}

//------------------------------------------------------------------------
//O
//------------------------------------------------------------------------
void CFace::CrossProduct(const D3DXVECTOR3& a,const D3DXVECTOR3& b)
{
	m_normal.x = a.y*b.z - a.z*b.y;
	m_normal.y = a.z*b.x - a.x*b.z;
	m_normal.z = a.x*b.y - a.y*b.x;
}

//------------------------------------------------------------------------
//Zq̃I[o[[h
//------------------------------------------------------------------------
CFace& CFace::operator=(const CFace& pt)
{
	m_material = pt.m_material;
	m_index = pt.m_index;
	m_uv = pt.m_uv;
	m_normal = pt.m_normal;
	m_vertex = pt.m_vertex;

	return *this;
}

//------------------------------------------------------------------------
//Zq̃I[o[[h
//------------------------------------------------------------------------
CFace::CFace (const CFace& pt)
{
	*this = pt;
}

//------------------------------------------------------------------------
//_ǉ
//------------------------------------------------------------------------
void CFace::PushBackVertex(CVertex v)
{
	m_vertex.push_back(v);
}

//------------------------------------------------------------------------
//_TCYύX
//------------------------------------------------------------------------
void CFace::ResizeVertex(int i)
{
	m_vertex.resize(i);
}

//------------------------------------------------------------------------
//_TCY擾
//------------------------------------------------------------------------
int CFace::GetVertexSize()
{
	return (int)m_vertex.size();
}

//------------------------------------------------------------------------
//_@Zbg
//------------------------------------------------------------------------
void CFace::SetVNormal(int i,D3DXVECTOR3 v)
{
	m_vertex[i].SetNormal(v);
}

//------------------------------------------------------------------------
//_@ǉ
//------------------------------------------------------------------------
void CFace::AddVNormal(int i,D3DXVECTOR3 v)
{
	m_vertex[i].AddNormal(v);
}

//------------------------------------------------------------------------
//_@擾
//------------------------------------------------------------------------
D3DXVECTOR3 CFace::GetVNormal(int i)
{
	return m_vertex[i].GetNormal();
}

//------------------------------------------------------------------------
//_ʒǉ
//------------------------------------------------------------------------
void CFace::PushBackHaveFaces(int i,int f)
{
	m_vertex[i].PushBackHaveFaces(f);
}

//------------------------------------------------------------------------
//_ʃTCY擾
//------------------------------------------------------------------------
int CFace::GetHaveFacesSize(int i)
{
	return m_vertex[i].GetHaveFacesSize();
}

//------------------------------------------------------------------------
//_ʎ擾
//------------------------------------------------------------------------
int CFace::GetHaveFaces(int i,int f)
{
	return m_vertex[i].GetHaveFaces(f);
}

//------------------------------------------------------------------------
//_@K
//------------------------------------------------------------------------
void CFace::VNormalize(int i)
{
	m_vertex[i].Normalize();
}
